= v1.PersistentVolume
{product-author}
{product-version}
:data-uri:
:icons:
:toc: macro
:toc-title:
:toclevels: 2

toc::[]

== Description
[%hardbreaks]
PersistentVolume (PV) is a storage resource provisioned by an administrator. It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

== Object Schema
Expand or mouse-over a field for more information about it.

++++
<pre>
<div style="margin-left:13px;"><span title="(string) APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources">apiVersion</span>:
</div><div style="margin-left:13px;"><span title="(string) Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">kind</span>:
</div><details open><summary><span title="(v1.ObjectMeta) Standard object&#39;s metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata">metadata</span>:
</summary><details><summary>  <span title="(object) Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations">annotations</span>:
</summary><div style="margin-left:13px;">    <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">  <span title="(string) The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.">clusterName</span>:
</div><div style="margin-left:13px;">  <span title="(v1.Time) CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.

Populated by the system. Read-only. Null for lists. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata">creationTimestamp</span>:
</div><div style="margin-left:13px;">  <span title="(integer) Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only.">deletionGracePeriodSeconds</span>:
</div><div style="margin-left:13px;">  <span title="(v1.Time) DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.

Populated by the system when a graceful deletion is requested. Read-only. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata">deletionTimestamp</span>:
</div><details><summary>  <span title="(array) Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.">finalizers</span>:
</summary><div style="margin-left:13px;">  - <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">  <span title="(string) GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).

Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency">generateName</span>:
</div><div style="margin-left:13px;">  <span title="(integer) A sequence number representing a specific generation of the desired state. Populated by the system. Read-only.">generation</span>:
</div><details><summary>  <span title="(v1.Initializers) An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven&#39;t explicitly asked to observe uninitialized objects.

When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.">initializers</span>:
</summary><details><summary>    <span title="(array) Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.">pending</span>:
</summary><div style="margin-left:13px;">    - <span title="(string) name of the process that is responsible for initializing this object.">name</span>:
</div></details><details><summary>    <span title="(v1.Status) If result is set with the Failure field, the object will be persisted to storage and then deleted, ensuring that other clients can observe the deletion.">result</span>:
</summary><div style="margin-left:13px;">      <span title="(string) APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#resources">apiVersion</span>:
</div><div style="margin-left:13px;">      <span title="(integer) Suggested HTTP return code for this status, 0 if not set.">code</span>:
</div><details><summary>      <span title="(v1.StatusDetails) Extended data associated with the reason.  Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.">details</span>:
</summary><details><summary>        <span title="(array) The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.">causes</span>:
</summary><div style="margin-left:13px;">        - <span title="(string) The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.

Examples:
  &#34;name&#34; - the field &#34;name&#34; on the current resource
  &#34;items[0].name&#34; - the field &#34;name&#34; on the first array entry in &#34;items&#34;">field</span>:
</div><div style="margin-left:13px;">          <span title="(string) A human-readable description of the cause of the error.  This field may be presented as-is to a reader.">message</span>:
</div><div style="margin-left:13px;">          <span title="(string) A machine-readable description of the cause of the error. If this value is empty there is no information available.">reason</span>:
</div></details><div style="margin-left:13px;">        <span title="(string) The group attribute of the resource associated with the status StatusReason.">group</span>:
</div><div style="margin-left:13px;">        <span title="(string) The kind attribute of the resource associated with the status StatusReason. On some operations may differ from the requested resource Kind. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">kind</span>:
</div><div style="margin-left:13px;">        <span title="(string) The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).">name</span>:
</div><div style="margin-left:13px;">        <span title="(integer) If specified, the time in seconds before the operation should be retried. Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.">retryAfterSeconds</span>:
</div><div style="margin-left:13px;">        <span title="(string) UID of the resource. (when there is a single resource which can be described). More info: http://kubernetes.io/docs/user-guide/identifiers#uids">uid</span>:
</div></details><div style="margin-left:13px;">      <span title="(string) Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">kind</span>:
</div><div style="margin-left:13px;">      <span title="(string) A human-readable description of the status of this operation.">message</span>:
</div><details><summary>      <span title="(v1.ListMeta) Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">metadata</span>:
</summary><div style="margin-left:13px;">        <span title="(string) continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response.">continue</span>:
</div><div style="margin-left:13px;">        <span title="(string) String that identifies the server&#39;s internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency">resourceVersion</span>:
</div><div style="margin-left:13px;">        <span title="(string) selfLink is a URL representing this object. Populated by the system. Read-only.">selfLink</span>:
</div></details><div style="margin-left:13px;">      <span title="(string) A machine-readable description of why this operation is in the &#34;Failure&#34; status. If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.">reason</span>:
</div><div style="margin-left:13px;">      <span title="(string) Status of the operation. One of: &#34;Success&#34; or &#34;Failure&#34;. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status">status</span>:
</div></details></details><details><summary>  <span title="(object) Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels">labels</span>:
</summary><div style="margin-left:13px;">    <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">  <span title="(string) Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names">name</span>:
</div><div style="margin-left:13px;">  <span title="(string) Namespace defines the space within each name must be unique. An empty namespace is equivalent to the &#34;default&#34; namespace, but &#34;default&#34; is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces">namespace</span>:
</div><details><summary>  <span title="(array) List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.">ownerReferences</span>:
</summary><div style="margin-left:13px;">  - <span title="(string) API version of the referent.">apiVersion</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) If true, AND if the owner has the &#34;foregroundDeletion&#34; finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs &#34;delete&#34; permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.">blockOwnerDeletion</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) If true, this reference points to the managing controller.">controller</span>:
</div><div style="margin-left:13px;">    <span title="(string) Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">kind</span>:
</div><div style="margin-left:13px;">    <span title="(string) Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names">name</span>:
</div><div style="margin-left:13px;">    <span title="(string) UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids">uid</span>:
</div></details><div style="margin-left:13px;">  <span title="(string) An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency">resourceVersion</span>:
</div><div style="margin-left:13px;">  <span title="(string) SelfLink is a URL representing this object. Populated by the system. Read-only.">selfLink</span>:
</div><div style="margin-left:13px;">  <span title="(string) UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: http://kubernetes.io/docs/user-guide/identifiers#uids">uid</span>:
</div></details><details open><summary><span title="(v1.PersistentVolumeSpec) Spec defines a specification of a persistent volume owned by the cluster. Provisioned by an administrator. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes">spec</span>:
</summary><details><summary>  <span title="(array) AccessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes">accessModes</span>:
</summary><div style="margin-left:13px;">  - <span title="(string)">[string]</span>:
</div></details><details><summary>  <span title="(v1.AWSElasticBlockStoreVolumeSource) AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet&#39;s host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore">awsElasticBlockStore</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(integer) The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as &#34;1&#34;. Similarly, the volume partition for /dev/sda is &#34;0&#34; (or you can leave the property empty).">partition</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Specify &#34;true&#34; to force and set the ReadOnly property in VolumeMounts to &#34;true&#34;. If omitted, the default is &#34;false&#34;. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore">readOnly</span>:
</div><div style="margin-left:13px;">    <span title="(string) Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore">volumeID</span>:
</div></details><details><summary>  <span title="(v1.AzureDiskVolumeSource) AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.">azureDisk</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Host Caching mode: None, Read Only, Read Write.">cachingMode</span>:
</div><div style="margin-left:13px;">    <span title="(string) The Name of the data disk in the blob storage">diskName</span>:
</div><div style="margin-left:13px;">    <span title="(string) The URI the data disk in the blob storage">diskURI</span>:
</div><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(string) Expected values Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared">kind</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div></details><details><summary>  <span title="(v1.AzureFilePersistentVolumeSource) AzureFile represents an Azure File Service mount on the host and bind mount to the pod.">azureFile</span>:
</summary><div style="margin-left:13px;">    <span title="(boolean) Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div><div style="margin-left:13px;">    <span title="(string) the name of secret that contains Azure Storage Account Name and Key">secretName</span>:
</div><div style="margin-left:13px;">    <span title="(string) the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod">secretNamespace</span>:
</div><div style="margin-left:13px;">    <span title="(string) Share Name">shareName</span>:
</div></details><details><summary>  <span title="(object) A description of the persistent volume&#39;s resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity">capacity</span>:
</summary><div style="margin-left:13px;">    <span title="(string)">[string]</span>:
</div></details><details><summary>  <span title="(v1.CephFSPersistentVolumeSource) CephFS represents a Ceph FS mount on the host that shares a pod&#39;s lifetime">cephfs</span>:
</summary><details><summary>    <span title="(array) Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it">monitors</span>:
</summary><div style="margin-left:13px;">    - <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) Optional: Used as the mounted root, rather than the full Ceph tree, default is /">path</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it">readOnly</span>:
</div><div style="margin-left:13px;">    <span title="(string) Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it">secretFile</span>:
</div><details><summary>    <span title="(v1.SecretReference) Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it">user</span>:
</div></details><details><summary>  <span title="(v1.CinderPersistentVolumeSource) Cinder represents a cinder volume attached and mounted on kubelets host machine More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md">cinder</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md">readOnly</span>:
</div><details><summary>    <span title="(v1.SecretReference) Optional: points to a secret object containing parameters used to connect to OpenStack.">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) volume id used to identify the volume in cinder More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md">volumeID</span>:
</div></details><details><summary>  <span title="(v1.ObjectReference) ClaimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. Expected to be non-nil when bound. claim.VolumeName is the authoritative bind between PV and PVC. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding">claimRef</span>:
</summary><div style="margin-left:13px;">    <span title="(string) API version of the referent.">apiVersion</span>:
</div><div style="margin-left:13px;">    <span title="(string) If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: &#34;spec.containers{name}&#34; (where &#34;name&#34; refers to the name of the container that triggered the event) or if no container name is specified &#34;spec.containers[2]&#34; (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.">fieldPath</span>:
</div><div style="margin-left:13px;">    <span title="(string) Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">kind</span>:
</div><div style="margin-left:13px;">    <span title="(string) Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names">name</span>:
</div><div style="margin-left:13px;">    <span title="(string) Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/">namespace</span>:
</div><div style="margin-left:13px;">    <span title="(string) Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency">resourceVersion</span>:
</div><div style="margin-left:13px;">    <span title="(string) UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids">uid</span>:
</div></details><details><summary>  <span title="(v1.CSIPersistentVolumeSource) CSI represents storage that handled by an external CSI driver (Beta feature).">csi</span>:
</summary><details><summary>    <span title="(v1.SecretReference) ControllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.">controllerPublishSecretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) Driver is the name of the driver to use for this volume. Required.">driver</span>:
</div><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;.">fsType</span>:
</div><details><summary>    <span title="(v1.SecretReference) NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.">nodePublishSecretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><details><summary>    <span title="(v1.SecretReference) NodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.">nodeStageSecretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(boolean) Optional: The value to pass to ControllerPublishVolumeRequest. Defaults to false (read/write).">readOnly</span>:
</div><details><summary>    <span title="(object) Attributes of the volume to publish.">volumeAttributes</span>:
</summary><div style="margin-left:13px;">      <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) VolumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. Required.">volumeHandle</span>:
</div></details><details><summary>  <span title="(v1.FCVolumeSource) FC represents a Fibre Channel resource that is attached to a kubelet&#39;s host machine and then exposed to the pod.">fc</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(integer) Optional: FC target lun number">lun</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div><details><summary>    <span title="(array) Optional: FC target worldwide names (WWNs)">targetWWNs</span>:
</summary><div style="margin-left:13px;">    - <span title="(string)">[string]</span>:
</div></details><details><summary>    <span title="(array) Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.">wwids</span>:
</summary><div style="margin-left:13px;">    - <span title="(string)">[string]</span>:
</div></details></details><details><summary>  <span title="(v1.FlexPersistentVolumeSource) FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.">flexVolume</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Driver is the name of the driver to use for this volume.">driver</span>:
</div><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. The default filesystem depends on FlexVolume script.">fsType</span>:
</div><details><summary>    <span title="(object) Optional: Extra command options if any.">options</span>:
</summary><div style="margin-left:13px;">      <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">    <span title="(boolean) Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div><details><summary>    <span title="(v1.SecretReference) Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details></details><details><summary>  <span title="(v1.FlockerVolumeSource) Flocker represents a Flocker volume attached to a kubelet&#39;s host machine and exposed to the pod for its usage. This depends on the Flocker control service being running">flocker</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Name of the dataset stored as metadata -&gt; name on the dataset for Flocker should be considered as deprecated">datasetName</span>:
</div><div style="margin-left:13px;">    <span title="(string) UUID of the dataset. This is unique identifier of a Flocker dataset">datasetUUID</span>:
</div></details><details><summary>  <span title="(v1.GCEPersistentDiskVolumeSource) GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet&#39;s host machine and then exposed to the pod. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk">gcePersistentDisk</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(integer) The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as &#34;1&#34;. Similarly, the volume partition for /dev/sda is &#34;0&#34; (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk">partition</span>:
</div><div style="margin-left:13px;">    <span title="(string) Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk">pdName</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk">readOnly</span>:
</div></details><details><summary>  <span title="(v1.GlusterfsVolumeSource) Glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod. Provisioned by an admin. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md">glusterfs</span>:
</summary><div style="margin-left:13px;">    <span title="(string) EndpointsName is the endpoint name that details Glusterfs topology. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod">endpoints</span>:
</div><div style="margin-left:13px;">    <span title="(string) Path is the Glusterfs volume path. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod">path</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod">readOnly</span>:
</div></details><details><summary>  <span title="(v1.HostPathVolumeSource) HostPath represents a directory on the host. Provisioned by a developer or tester. This is useful for single-node development and testing only! On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath">hostPath</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath">path</span>:
</div><div style="margin-left:13px;">    <span title="(string) Type for HostPath Volume Defaults to &#34;&#34; More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath">type</span>:
</div></details><details><summary>  <span title="(v1.ISCSIPersistentVolumeSource) ISCSI represents an ISCSI Disk resource that is attached to a kubelet&#39;s host machine and then exposed to the pod. Provisioned by an admin.">iscsi</span>:
</summary><div style="margin-left:13px;">    <span title="(boolean) whether support iSCSI Discovery CHAP authentication">chapAuthDiscovery</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) whether support iSCSI Session CHAP authentication">chapAuthSession</span>:
</div><div style="margin-left:13px;">    <span title="(string) Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(string) Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface &lt;target portal&gt;:&lt;volume name&gt; will be created for the connection.">initiatorName</span>:
</div><div style="margin-left:13px;">    <span title="(string) Target iSCSI Qualified Name.">iqn</span>:
</div><div style="margin-left:13px;">    <span title="(string) iSCSI Interface Name that uses an iSCSI transport. Defaults to &#39;default&#39; (tcp).">iscsiInterface</span>:
</div><div style="margin-left:13px;">    <span title="(integer) iSCSI Target Lun number.">lun</span>:
</div><details><summary>    <span title="(array) iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).">portals</span>:
</summary><div style="margin-left:13px;">    - <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">    <span title="(boolean) ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.">readOnly</span>:
</div><details><summary>    <span title="(v1.SecretReference) CHAP Secret for iSCSI target and initiator authentication">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).">targetPortal</span>:
</div></details><details><summary>  <span title="(v1.LocalVolumeSource) Local represents directly-attached storage with node affinity">local</span>:
</summary><div style="margin-left:13px;">    <span title="(string) The full path to the volume on the node. It can be either a directory or block device (disk, partition, ...). Directories can be represented only by PersistentVolume with VolumeMode=Filesystem. Block devices can be represented only by VolumeMode=Block, which also requires the BlockVolume alpha feature gate to be enabled.">path</span>:
</div></details><details><summary>  <span title="(array) A list of mount options, e.g. [&#34;ro&#34;, &#34;soft&#34;]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options">mountOptions</span>:
</summary><div style="margin-left:13px;">  - <span title="(string)">[string]</span>:
</div></details><details><summary>  <span title="(v1.NFSVolumeSource) NFS represents an NFS mount on the host. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs">nfs</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs">path</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs">readOnly</span>:
</div><div style="margin-left:13px;">    <span title="(string) Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs">server</span>:
</div></details><details><summary>  <span title="(v1.VolumeNodeAffinity) NodeAffinity defines constraints that limit what nodes this volume can be accessed from. This field influences the scheduling of pods that use this volume.">nodeAffinity</span>:
</summary><details><summary>    <span title="(v1.NodeSelector) Required specifies hard node constraints that must be met.">required</span>:
</summary><details><summary>      <span title="(array) Required. A list of node selector terms. The terms are ORed.">nodeSelectorTerms</span>:
</summary><details><summary>      - <span title="(array) A list of node selector requirements by node&#39;s labels.">matchExpressions</span>:
</summary><div style="margin-left:13px;">      - - <span title="(string) The label key that the selector applies to.">key</span>:
</div><div style="margin-left:13px;">          <span title="(string) Represents a key&#39;s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.">operator</span>:
</div><details><summary>          <span title="(array) An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.">values</span>:
</summary><div style="margin-left:13px;">          - <span title="(string)">[string]</span>:
</div></details></details><details><summary>        <span title="(array) A list of node selector requirements by node&#39;s fields.">matchFields</span>:
</summary><div style="margin-left:13px;">        - <span title="(string) The label key that the selector applies to.">key</span>:
</div><div style="margin-left:13px;">          <span title="(string) Represents a key&#39;s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.">operator</span>:
</div><details><summary>          <span title="(array) An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.">values</span>:
</summary><div style="margin-left:13px;">          - <span title="(string)">[string]</span>:
</div></details></details></details></details></details><div style="margin-left:13px;">  <span title="(string) What happens to a persistent volume when released from its claim. Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming">persistentVolumeReclaimPolicy</span>:
</div><details><summary>  <span title="(v1.PhotonPersistentDiskVolumeSource) PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine">photonPersistentDisk</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(string) ID that identifies Photon Controller persistent disk">pdID</span>:
</div></details><details><summary>  <span title="(v1.PortworxVolumeSource) PortworxVolume represents a portworx volume attached and mounted on kubelets host machine">portworxVolume</span>:
</summary><div style="margin-left:13px;">    <span title="(string) FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div><div style="margin-left:13px;">    <span title="(string) VolumeID uniquely identifies a Portworx volume">volumeID</span>:
</div></details><details><summary>  <span title="(v1.QuobyteVolumeSource) Quobyte represents a Quobyte mount on the host that shares a pod&#39;s lifetime">quobyte</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Group to map volume access to Default is no group">group</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.">readOnly</span>:
</div><div style="margin-left:13px;">    <span title="(string) Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes">registry</span>:
</div><div style="margin-left:13px;">    <span title="(string) User to map volume access to Defaults to serivceaccount user">user</span>:
</div><div style="margin-left:13px;">    <span title="(string) Volume is a string that references an already created Quobyte volume by name.">volume</span>:
</div></details><details><summary>  <span title="(v1.RBDPersistentVolumeSource) RBD represents a Rados Block Device mount on the host that shares a pod&#39;s lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md">rbd</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(string) The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">image</span>:
</div><div style="margin-left:13px;">    <span title="(string) Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">keyring</span>:
</div><details><summary>    <span title="(array) A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">monitors</span>:
</summary><div style="margin-left:13px;">    - <span title="(string)">[string]</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">pool</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">readOnly</span>:
</div><details><summary>    <span title="(v1.SecretReference) SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it">user</span>:
</div></details><details><summary>  <span title="(v1.ScaleIOPersistentVolumeSource) ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.">scaleIO</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(string) The host address of the ScaleIO API Gateway.">gateway</span>:
</div><div style="margin-left:13px;">    <span title="(string) The name of the ScaleIO Protection Domain for the configured storage.">protectionDomain</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div><details><summary>    <span title="(v1.SecretReference) SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) Name is unique within a namespace to reference a secret resource.">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace defines the space within which the secret name must be unique.">namespace</span>:
</div></details><div style="margin-left:13px;">    <span title="(boolean) Flag to enable/disable SSL communication with Gateway, default false">sslEnabled</span>:
</div><div style="margin-left:13px;">    <span title="(string) Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.">storageMode</span>:
</div><div style="margin-left:13px;">    <span title="(string) The ScaleIO Storage Pool associated with the protection domain.">storagePool</span>:
</div><div style="margin-left:13px;">    <span title="(string) The name of the storage system as configured in ScaleIO.">system</span>:
</div><div style="margin-left:13px;">    <span title="(string) The name of a volume already created in the ScaleIO system that is associated with this volume source.">volumeName</span>:
</div></details><div style="margin-left:13px;">  <span title="(string) Name of StorageClass to which this persistent volume belongs. Empty value means that this volume does not belong to any StorageClass.">storageClassName</span>:
</div><details><summary>  <span title="(v1.StorageOSPersistentVolumeSource) StorageOS represents a StorageOS volume that is attached to the kubelet&#39;s host machine and mounted into the pod More info: https://releases.k8s.io/HEAD/examples/volumes/storageos/README.md">storageos</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(boolean) Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.">readOnly</span>:
</div><details><summary>    <span title="(v1.ObjectReference) SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.">secretRef</span>:
</summary><div style="margin-left:13px;">      <span title="(string) API version of the referent.">apiVersion</span>:
</div><div style="margin-left:13px;">      <span title="(string) If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: &#34;spec.containers{name}&#34; (where &#34;name&#34; refers to the name of the container that triggered the event) or if no container name is specified &#34;spec.containers[2]&#34; (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.">fieldPath</span>:
</div><div style="margin-left:13px;">      <span title="(string) Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds">kind</span>:
</div><div style="margin-left:13px;">      <span title="(string) Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names">name</span>:
</div><div style="margin-left:13px;">      <span title="(string) Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/">namespace</span>:
</div><div style="margin-left:13px;">      <span title="(string) Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency">resourceVersion</span>:
</div><div style="margin-left:13px;">      <span title="(string) UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids">uid</span>:
</div></details><div style="margin-left:13px;">    <span title="(string) VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.">volumeName</span>:
</div><div style="margin-left:13px;">    <span title="(string) VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod&#39;s namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to &#34;default&#34; if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.">volumeNamespace</span>:
</div></details><div style="margin-left:13px;">  <span title="(string) volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. Value of Filesystem is implied when not included in spec. This is an alpha feature and may change in the future.">volumeMode</span>:
</div><details><summary>  <span title="(v1.VsphereVirtualDiskVolumeSource) VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine">vsphereVolume</span>:
</summary><div style="margin-left:13px;">    <span title="(string) Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. &#34;ext4&#34;, &#34;xfs&#34;, &#34;ntfs&#34;. Implicitly inferred to be &#34;ext4&#34; if unspecified.">fsType</span>:
</div><div style="margin-left:13px;">    <span title="(string) Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.">storagePolicyID</span>:
</div><div style="margin-left:13px;">    <span title="(string) Storage Policy Based Management (SPBM) profile name.">storagePolicyName</span>:
</div><div style="margin-left:13px;">    <span title="(string) Path that identifies vSphere volume vmdk">volumePath</span>:
</div></details></details><details><summary><span title="(v1.PersistentVolumeStatus) Status represents the current information/status for the persistent volume. Populated by the system. Read-only. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes">status</span>:
</summary><div style="margin-left:13px;">  <span title="(string) A human-readable message indicating details about why the volume is in this state.">message</span>:
</div><div style="margin-left:13px;">  <span title="(string) Phase indicates if a volume is available, bound to a claim, or released by a claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#phase">phase</span>:
</div><div style="margin-left:13px;">  <span title="(string) Reason is a brief CamelCase string that describes any failure and is meant for machine parsing and tidy display in the CLI.">reason</span>:
</div></details>
</pre>
++++

== Operations

[[Post-api-v1-persistentvolumes]]
=== Create a PersistentVolume
Create a PersistentVolume

==== HTTP request
----
POST /api/v1/persistentvolumes HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
Content-Type: application/json'

{
  "kind": "PersistentVolume",
  "apiVersion": "v1",
  ...
}

----

==== Curl request
----
$ curl -k \
    -X POST \
    -d @- \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes <<'EOF'
{
  "kind": "PersistentVolume",
  "apiVersion": "v1",
  ...
}
EOF
----

==== HTTP body
[cols="1,5", options="header"]
|===
|Parameter|Schema
|body|v1.PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|201 Created|v1.PersistentVolume
|202 Accepted|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Get-api-v1-persistentvolumes-name]]
=== Get a PersistentVolume
Read the specified PersistentVolume

==== HTTP request
----
GET /api/v1/persistentvolumes/$NAME HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
----

==== Curl request
----
$ curl -k \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME
----

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|exact|Should the export be exact.  Exact export maintains cluster-specific fields like 'Namespace'.
|export|Should this value be exported.  Export strips fields that a user can not specify.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Get-api-v1-persistentvolumes]]
=== Get all PersistentVolumes
List or watch objects of kind PersistentVolume

==== HTTP request
----
GET /api/v1/persistentvolumes HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
----

==== Curl request
----
$ curl -k \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes
----

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|continue|The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server the server will respond with a 410 ResourceExpired error indicating the client must restart their list without the continue field. This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
|fieldSelector|A selector to restrict the list of returned objects by their fields. Defaults to everything.
|includeUninitialized|If true, partially initialized resources are included in the response.
|labelSelector|A selector to restrict the list of returned objects by their labels. Defaults to everything.
|limit|limit is a maximum number of responses to return for a list call. If more items exist, the server will set the `continue` field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.

The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
|resourceVersion|When specified with a watch call, shows changes that occur after that particular version of a resource. Defaults to changes from the beginning of history. When specified for list: - if unset, then the result is returned from remote storage based on quorum-read flag; - if it's 0, then we simply return what we currently have in cache, no guarantee; - if set to non zero, then the result is at least as fresh as given rv.
|timeoutSeconds|Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
|watch|Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolumeList
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf
* application/json;stream=watch
* application/vnd.kubernetes.protobuf;stream=watch


[[Get-api-v1-watch-persistentvolumes-name]]
=== Watch a PersistentVolume
Watch changes to an object of kind PersistentVolume

==== HTTP request
----
GET /api/v1/watch/persistentvolumes/$NAME HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
----

==== Curl request
----
$ curl -k \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    https://$ENDPOINT/api/v1/watch/persistentvolumes/$NAME
----

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|continue|The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server the server will respond with a 410 ResourceExpired error indicating the client must restart their list without the continue field. This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
|fieldSelector|A selector to restrict the list of returned objects by their fields. Defaults to everything.
|includeUninitialized|If true, partially initialized resources are included in the response.
|labelSelector|A selector to restrict the list of returned objects by their labels. Defaults to everything.
|limit|limit is a maximum number of responses to return for a list call. If more items exist, the server will set the `continue` field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.

The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
|pretty|If 'true', then the output is pretty printed.
|resourceVersion|When specified with a watch call, shows changes that occur after that particular version of a resource. Defaults to changes from the beginning of history. When specified for list: - if unset, then the result is returned from remote storage based on quorum-read flag; - if it's 0, then we simply return what we currently have in cache, no guarantee; - if set to non zero, then the result is at least as fresh as given rv.
|timeoutSeconds|Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
|watch|Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.WatchEvent
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf
* application/json;stream=watch
* application/vnd.kubernetes.protobuf;stream=watch


[[Get-api-v1-watch-persistentvolumes]]
=== Watch all PersistentVolumes
Watch individual changes to a list of PersistentVolume

==== HTTP request
----
GET /api/v1/watch/persistentvolumes HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
----

==== Curl request
----
$ curl -k \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    https://$ENDPOINT/api/v1/watch/persistentvolumes
----

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|continue|The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server the server will respond with a 410 ResourceExpired error indicating the client must restart their list without the continue field. This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
|fieldSelector|A selector to restrict the list of returned objects by their fields. Defaults to everything.
|includeUninitialized|If true, partially initialized resources are included in the response.
|labelSelector|A selector to restrict the list of returned objects by their labels. Defaults to everything.
|limit|limit is a maximum number of responses to return for a list call. If more items exist, the server will set the `continue` field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.

The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
|pretty|If 'true', then the output is pretty printed.
|resourceVersion|When specified with a watch call, shows changes that occur after that particular version of a resource. Defaults to changes from the beginning of history. When specified for list: - if unset, then the result is returned from remote storage based on quorum-read flag; - if it's 0, then we simply return what we currently have in cache, no guarantee; - if set to non zero, then the result is at least as fresh as given rv.
|timeoutSeconds|Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
|watch|Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.WatchEvent
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf
* application/json;stream=watch
* application/vnd.kubernetes.protobuf;stream=watch


[[Put-api-v1-persistentvolumes-name]]
=== Update a PersistentVolume
Replace the specified PersistentVolume

==== HTTP request
----
PUT /api/v1/persistentvolumes/$NAME HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
Content-Type: application/json'

{
  "kind": "PersistentVolume",
  "apiVersion": "v1",
  ...
}

----

==== Curl request
----
$ curl -k \
    -X PUT \
    -d @- \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME <<'EOF'
{
  "kind": "PersistentVolume",
  "apiVersion": "v1",
  ...
}
EOF
----

==== HTTP body
[cols="1,5", options="header"]
|===
|Parameter|Schema
|body|v1.PersistentVolume
|===

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|201 Created|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Patch-api-v1-persistentvolumes-name]]
=== Patch a PersistentVolume
Partially update the specified PersistentVolume

==== HTTP request
----
PATCH /api/v1/persistentvolumes/$NAME HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
Content-Type: application/json-patch+json'

{
  ...
}

----

==== Curl request
----
$ curl -k \
    -X PATCH \
    -d @- \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json-patch+json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME <<'EOF'
{
  ...
}
EOF
----

==== HTTP body
[cols="1,5", options="header"]
|===
|Parameter|Schema
|body|v1.Patch
|===

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* application/json-patch+json
* application/merge-patch+json
* application/strategic-merge-patch+json

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Delete-api-v1-persistentvolumes-name]]
=== Delete a PersistentVolume
Delete a PersistentVolume

==== HTTP request
----
DELETE /api/v1/persistentvolumes/$NAME HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
Content-Type: application/json'

{
  ...
}

----

==== Curl request
----
$ curl -k \
    -X DELETE \
    -d @- \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME <<'EOF'
{
  ...
}
EOF
----

==== HTTP body
[cols="1,5", options="header"]
|===
|Parameter|Schema
|body|v1.DeleteOptions
|===

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|gracePeriodSeconds|The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.
|orphanDependents|Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both.
|propagationPolicy|Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: 'Orphan' - orphan the dependents; 'Background' - allow the garbage collector to delete the dependents in the background; 'Foreground' - a cascading policy that deletes all dependents in the foreground.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.Status
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Delete-api-v1-persistentvolumes]]
=== Delete all PersistentVolumes
Delete collection of PersistentVolume

==== HTTP request
----
DELETE /api/v1/persistentvolumes HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
----

==== Curl request
----
$ curl -k \
    -X DELETE \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes
----

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|continue|The continue option should be set when retrieving more results from the server. Since this value is server defined, clients may only use the continue value from a previous query result with identical query parameters (except for the value of continue) and the server may reject a continue value it does not recognize. If the specified continue value is no longer valid whether due to expiration (generally five to fifteen minutes) or a configuration change on the server the server will respond with a 410 ResourceExpired error indicating the client must restart their list without the continue field. This field is not supported when watch is true. Clients may start a watch from the last resourceVersion value returned by the server and not miss any modifications.
|fieldSelector|A selector to restrict the list of returned objects by their fields. Defaults to everything.
|includeUninitialized|If true, partially initialized resources are included in the response.
|labelSelector|A selector to restrict the list of returned objects by their labels. Defaults to everything.
|limit|limit is a maximum number of responses to return for a list call. If more items exist, the server will set the `continue` field on the list metadata to a value that can be used with the same initial query to retrieve the next set of results. Setting a limit may return fewer than the requested amount of items (up to zero items) in the event all requested objects are filtered out and clients should only use the presence of the continue field to determine whether more results are available. Servers may choose not to support the limit argument and will return all of the available results. If limit is specified and the continue field is empty, clients may assume that no more results are available. This field is not supported if watch is true.

The server guarantees that the objects returned when using continue will be identical to issuing a single list call without a limit - that is, no objects created, modified, or deleted after the first request is issued will be included in any subsequent continued requests. This is sometimes referred to as a consistent snapshot, and ensures that a client that is using limit to receive smaller chunks of a very large result can ensure they see all possible objects. If objects are updated during a chunked list the version of the object that was present at the time the first list result was calculated is returned.
|resourceVersion|When specified with a watch call, shows changes that occur after that particular version of a resource. Defaults to changes from the beginning of history. When specified for list: - if unset, then the result is returned from remote storage based on quorum-read flag; - if it's 0, then we simply return what we currently have in cache, no guarantee; - if set to non zero, then the result is at least as fresh as given rv.
|timeoutSeconds|Timeout for the list/watch call. This limits the duration of the call, regardless of any activity or inactivity.
|watch|Watch for changes to the described resources and return them as a stream of add, update, and remove notifications. Specify resourceVersion.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.Status
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Get-api-v1-persistentvolumes-name-status]]
=== Get status of a PersistentVolume
Read status of the specified PersistentVolume

==== HTTP request
----
GET /api/v1/persistentvolumes/$NAME/status HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
----

==== Curl request
----
$ curl -k \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME/status
----

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Put-api-v1-persistentvolumes-name-status]]
=== Update status of a PersistentVolume
Replace status of the specified PersistentVolume

==== HTTP request
----
PUT /api/v1/persistentvolumes/$NAME/status HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
Content-Type: application/json'

{
  "kind": "PersistentVolume",
  "apiVersion": "v1",
  ...
}

----

==== Curl request
----
$ curl -k \
    -X PUT \
    -d @- \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME/status <<'EOF'
{
  "kind": "PersistentVolume",
  "apiVersion": "v1",
  ...
}
EOF
----

==== HTTP body
[cols="1,5", options="header"]
|===
|Parameter|Schema
|body|v1.PersistentVolume
|===

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|201 Created|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* \*/*

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf


[[Patch-api-v1-persistentvolumes-name-status]]
=== Patch status of a PersistentVolume
Partially update status of the specified PersistentVolume

==== HTTP request
----
PATCH /api/v1/persistentvolumes/$NAME/status HTTP/1.1
Authorization: Bearer $TOKEN
Accept: application/json
Connection: close
Content-Type: application/json-patch+json'

{
  ...
}

----

==== Curl request
----
$ curl -k \
    -X PATCH \
    -d @- \
    -H "Authorization: Bearer $TOKEN" \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json-patch+json' \
    https://$ENDPOINT/api/v1/persistentvolumes/$NAME/status <<'EOF'
{
  ...
}
EOF
----

==== HTTP body
[cols="1,5", options="header"]
|===
|Parameter|Schema
|body|v1.Patch
|===

==== Path parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|name|name of the PersistentVolume
|===

==== Query parameters
[cols="1,5", options="header"]
|===
|Parameter|Description
|pretty|If 'true', then the output is pretty printed.
|===

==== Responses
[cols="1,5", options="header"]
|===
|HTTP Code|Schema
|200 OK|v1.PersistentVolume
|401 Unauthorized|
|===

==== Consumes

* application/json-patch+json
* application/merge-patch+json
* application/strategic-merge-patch+json

==== Produces

* application/json
* application/yaml
* application/vnd.kubernetes.protobuf



